-- MoonTimeLayoutObj.lua

function MoonTimeLayoutObj()
	-- dieses Frame besitzt die Funktionen:
	-- GetStarrainCD
	-- GetTreantsCD
	-- GetStarsurgeCD
	-- GetMoonfireCD
	-- GetInsectSwarmCD
	-- GetEclipseEndTimes
	-- Next()
	local frame = CreateFrame( "Frame" )
	
	local expirationTime, start, duration, enabled, unitCaster, name, texture, active
	local hpdiff, timediff, timetilldeath, dir, power, EDir, EPower, spell, startTime, endTime, castID, change
	
	
	
	frame.GetStarfallDuration = function()
		_, _, _, _, _, _, expirationTime = UnitBuff("player", SR_name) 
		
		if expirationTime == nil then 
			return 0
		end
		
		return expirationTime-GetTime();
	end
	
	frame.GetStarfallCD = function()
		start, duration, enabled = GetSpellCooldown(SR_id);
		if duration < 2 then return 0 end
		return start+duration-GetTime();
	end
	
	frame.GetTreantsCD = function()
		start, duration, enabled = GetSpellCooldown(Treants_id);
		
		return start+duration-GetTime();
	end

	frame.GetStarsurgeCD = function()
		start, duration, enabled = GetSpellCooldown(SS_id);
		return start+duration-GetTime();
	end
	
	frame.GetMoonfireCD = function()
		_, _, _, _, _, duration, expirationTime, unitCaster = UnitDebuff("target", MF_name);
		
		if unitCaster=="player" then
			return expirationTime-GetTime(), duration;
		else
			return -1, GetTime();
		end
	end

	frame.GetSunfireCD = function()
		_, _, _, _, _, duration, expirationTime, unitCaster = UnitDebuff("target", SunF_name);
		
		if unitCaster=="player" then
			return expirationTime-GetTime(), duration;
		else
			return -1, GetTime();
		end
	end

	frame.GetInsectSwarmCD = function()
		_, _, _, _, _, _, expirationTime, unitCaster = UnitDebuff("target", IS_name);
		
		if unitCaster=="player" then
			return expirationTime-GetTime();
		else
			return -1;
		end
	end
	
	frame.GetFaerieFireCD = function()
		_, _, _, _, _, _, expirationTime, unitCaster = UnitDebuff("target", FF_name);
		
		if unitCaster=="player" then
			return expirationTime-GetTime();
		else
			return -1;
		end
	end
	
	frame.GetCelestialAlignmentCD = function()
		start, duration = GetSpellCooldown(CA_id);
		return start+duration-GetTime();
	end	

	frame.GetTalentCD = function( self, talentNumber )
		name, texture, _, _, active = GetTalentInfo(talentNumber)
		
		if active then
			start, duration, enabled = GetSpellCooldown(name);	
				if duration < 2 then return 0, duration end
			return start+duration-GetTime(), duration;
		else
			return -1, 0
		end
	end

	frame.GetRejuvenationDuration = function()
		_, _, _, _, _, duration, expirationTime, unitCaster = UnitBuff("player", R_name);
		
		if unitCaster=="player" then
			return expirationTime-GetTime(), duration;
		else
			return -1;
		end			
	end	
	
	
	
	
		local ttd = {
	
	["hp"] = 0,
	["timestamp"] = 0,
	["ttd"] = 0,
};
	
	frame.TimeTillDeath = function ()
	
		tmp = GetTime()
		
		if tmp - 1 > ttd["timestamp"] then
			hpdiff = ttd["hp"]-UnitHealth("target")
			timediff = tmp-ttd["timestamp"]
			timetilldeath = UnitHealth("target")/hpdiff*timediff
			
			if timetilldeath then
				ttd["ttd"] = timetilldeath
			end
		
		
			ttd["hp"] = UnitHealth("target")
			ttd["timestamp"] = tmp
		
		end
		
		return ttd["ttd"] 
		
		
		
	end
	
	frame.GetEclipseDirection = function()
		dir = GetEclipseDirection()
		
		--DEFAULT_CHAT_FRAME:AddMessage(dir)
		
		if ( dir == "none" ) then
			dir = "sun";
		end
		local power = UnitPower("player", 8)
		
		return dir, power
	end

	frame.GetFutureEclipseDirection = function()
		EDir, EPower = frame.GetEclipseDirection()
		
		spell = UnitCastingInfo("player");
	
		local change = 0;

		if spell == SF_name and EDir == "sun" then
			change = 20;
		end

		if spell == W_name and EDir == "moon"  then
			change = -15;
		end

		if spell == SS_name then
			if EDir == "moon" then
				change = -20;
			else
				change = 20;
			end
		end

		if not frame:isSolar() and not frame:isLunar() then
			change = 2*change;
		end

		EPower = EPower + change;
		
		if EPower > 100 then
			EPower = 100
		elseif EPower < -100 then
			EPower = -100
		end
		
		if EDir == "moon" and EPower == -100 then
			EDir = "sun"
		elseif EDir == "sun" and EPower == 100 then
			EDir = "moon"
		end
		
		return dir, EPower
	end

	frame.isSolar = function()
		name = UnitBuff("player", Solar_name);
		if ( name ) then
			return true
		else
			return false
		end
	end

	frame.isLunar = function()
		name = UnitBuff("player", Lunar_name);
		if ( name ) then
			return true
		else
			return false
		end
	end	


	frame.GetCelestialAlignmentDuration = function()
		name, _, _, _, _, _, expirationTime = UnitBuff("player", CA_name);

		if name then
			return expirationTime-GetTime();
		else
			return -1
		end
	end	
	
	frame.getFuturePower = function(self, spell, EDir, EPower)
		if endTime == nil then endTime = 0 end

		
		change = 0;

		if spell == SF_name and EDir == "sun" then
			change = 20;
		end

		if spell == W_name and EDir == "moon"  then
			change = -15;
		end

		if spell == SS_name then
			if EDir == "moon" then
				change = -20;
			else
				change = 20;
			end
		end

		if not frame:isSolar() and not frame:isLunar() then
			change = 2*change;
		end

		EPower = EPower + change;

		if EPower > 100 then
			EPower = 100
		elseif EPower < -100 then
			EPower = -100
		end		
		
		if EDir == "sun" and EPower == 100 then
			EDir = "moon"
		end
		
		if EDir == "moon" and EPower == -100 then
			EDir = "sun"
		end
		
		
		
	return EDir, EPower
	
	end

	frame.isSSproc = function()
		name = UnitBuff("player", SS_proc_name);
		if ( name ) then
			return true
		else
			return false
		end
	end	
		




	return frame
end
		
	